function [EST,TAB] = SampleGibbsRW(IYm,FUN,j1,j2,Ni,Nj,Nmc,Nbi)

if nargin<8; Nbi = 1000; end
if nargin<7; Nmc = 2000; end

% Parameters
walkvarcom = 0.05;NbLeaders = sum(Ni); NbLeaders = sum(prod(Nj(j1:j2),2));

walkvar_c2 = walkvarcom^.5/sqrt(NbLeaders);walkvar_c20 = 4*walkvar_c2;
Mj1 = [j1*log(2) 1] ;Mj2 = [j2*log(2) 1];
% Initialization
nwind = 50; Vacc_c2 = randn(1,nwind)<0.0;Vacc_c20 = randn(1,nwind)<0.0;
c2  = -0.04;c20 = 0.5; C_est = [c2;c20]; tabC = zeros(2,Nmc);
rndn = randn(Nmc,2);rndn = [rndn,rand(Nmc,2)];

PSD = (C_est'*FUN);IND = PSD > 0; PSD = abs(PSD);
U = 0.5*(sum(IND.*Ni.*log(PSD))+sum(IND.*IYm./PSD));

Crit=zeros(1,Nmc+1);
Crit0=zeros(1,Nmc+1);

%% Iterations
for t=1:Nmc
    
    % Tuning and control of BOTH step sizes
    mVacc_c2(t) = mean(Vacc_c2); mVacc_c20(t) = mean(Vacc_c20);
    if mVacc_c2(t)<0.4;
        Vacc_c2 = randn(1,nwind)<0.0;walkvar_c2 = walkvar_c2*0.75;
    else
        if mVacc_c2(t)>0.6
            Vacc_c2 = randn(1,nwind)<0.0;walkvar_c2 = walkvar_c2*1.25;
        end
    end
    if mVacc_c20(t)<0.4;
        Vacc_c20 = randn(1,nwind)<0.0;walkvar_c20 = walkvar_c20*0.75;
    else
        if mVacc_c20(t)>0.6
            Vacc_c20 = randn(1,nwind)<0.0;walkvar_c20 = walkvar_c20*1.25;
        end
    end
    % Update c2
    Ccand  = C_est + [1;0]*walkvar_c2*rndn(t,1);
    if (Mj1*Ccand<0) || (Mj2*Ccand<0)
        Vacc_c2 = [Vacc_c2(2:end) 0];
        Crit(t+1)=Crit(t);
    else
        PSDcand = (Ccand'*FUN); INDcand = PSDcand > 0; PSDcand = abs(PSDcand);
        Ucand = 0.5*(sum(INDcand.*Ni.*log(PSDcand))+sum(INDcand.*IYm./PSDcand));
        
        if rndn(t,3)<min(1,exp((U) - (Ucand)))   % Test
            C_est(1) = Ccand(1);U = Ucand;Vacc_c2= [Vacc_c2(2:end) 1];
        else
            Vacc_c2 = [Vacc_c2(2:end) 0];
        end
        Crit(t+1)=U;
    end
    % Update c20
    Ccand  = C_est + [0;1]*walkvar_c20*rndn(t,2);
    if (Mj1*Ccand<0) || (Mj2*Ccand<0)
        Vacc_c20 = [Vacc_c20(2:end) 0];
        Crit0(t+1)=Crit0(t);
    else
        PSDcand = (Ccand'*FUN); INDcand = PSDcand > 0; PSDcand = abs(PSDcand);
        Ucand = 0.5*(sum(INDcand.*Ni.*log(PSDcand))+sum(INDcand.*IYm./PSDcand));
        
        if rndn(t,4)<min(1,exp((U) - (Ucand)))   % Test
            C_est(2) = Ccand(2);U = Ucand;Vacc_c20= [Vacc_c20(2:end) 1];
        else
            Vacc_c20 = [Vacc_c20(2:end) 0];
        end
        Crit0(t+1)=U;
    end
    tabC(:,t) = C_est;

end

% - OUTPUTS
EST.c2.MMSE = mean(tabC(1,Nbi:end));EST.c20.MMSE = mean(tabC(2,Nbi:end));
% EST.walkvar_c2 = walkvar_c2;EST.walkvar_c20 = walkvar_c20;
TAB.c2 = tabC(1,:);TAB.c20=tabC(2,:);
TAB.critc2=-Crit(2:end); [tmp,id]=max(-Crit(2:end)); EST.c2.MAP=tabC(1,id);
TAB.critc20=-Crit0(2:end); [tmp,id]=max(-Crit0(2:end)); EST.c20.MAP=tabC(2,id);

end
