function [EST,TAB] = SampleHMC_Langevin(IYm,LLc,j1,j2,Ni,Nj)
% CAUTION : - prior -- a non-informative normal law 

% HMC Parameters
Nmc = 4000;Nbi= 2000;
walkvarcom   = 0.05; NbLeaders = sum(Ni); NbLeaders = sum(prod(Nj(j1:j2),2)); 
walkvar_c2 = walkvarcom^.5/sqrt(NbLeaders); walkvar_c20  = 4*walkvar_c2; delta = [walkvar_c2;walkvar_c20];
% Initialization
nwind = 50; Vacc = randn(1,nwind)<0.0;
c2  = -0.04;c20 = 0.3;C_est = [c2;c20]; tabC = zeros(2,Nmc);
% Gaussian prior on (c2,c20) N(Cm,SIG)
STD     = [2 0;0 2];iSIG = inv(STD.^2);CMM = [-0.06 0.3]';
% Derivative
reLLc = real(LLc); imLLc = imag(LLc);
reLc2 = reLLc(1,:); imLc2 = imLLc(1,:); reLc20 = reLLc(2,:); imLc20 = imLLc(2,:);
dc2  = [reLc2.^2 + imLc2.^2; reLc2.*reLc20 + imLc2.*imLc20]; dc20 = [reLc2.*reLc20 + imLc2.*imLc20; reLc20.^2 + imLc20.^2];

Crit=zeros(1,Nmc+1);
% - SAMPLING
for t= 1:Nmc
    %keyboard
    %waitbar(t/Nmc);
    if t<Nbi; % Adaptative stepsizes
        mVacc(t) = mean(Vacc);
        if mVacc(t) < 0.3;
            Vacc = randn(1,nwind)<0.0; delta = delta*0.75;
        elseif mVacc(t) > 0.7;
            Vacc = randn(1,nwind)<0.0; delta = delta*1.25;
        end
    end
    C0 = C_est; % Current state
    %----------------------------------------------------------------------
    % Langevin : One step
    %----------------------------------------------------------------------
    % Update
    p0 = randn(2,1);
    PSD0 = (C0'*LLc); IND0 = PSD0 >0 ; PSD0 = abs(PSD0);
    tp0 = (Ni-IYm./PSD0)./(PSD0.^2); dU0 = 0.5*[sum((C0'*dc2).* tp0);sum((C0'*dc20).*tp0)] +iSIG*(C0-CMM);
    %dU0 = 0.5*[sum(Lc2.* tp0);sum(Lc20.*tp0)] +iSIG*(C0-CMM);
    %eval(tdU0);
    CS = C0 - 0.5*(delta.^2).*dU0 + delta.*p0;
    
    PSDS = (CS'*LLc); INDS = PSDS >0 ; PSDS = abs(PSDS);
    tpS = (Ni-IYm./PSDS)./(PSDS.^2); dUS = 0.5*[sum((CS'*dc2).* tpS);sum((CS'*dc20).*tpS)] +iSIG*(CS-CMM);
    %tpS= INDS.*(Ni-IYm./PSDS)./PSDS; dUS = 0.5*[sum(Lc2.* tpS);sum(Lc20.*tpS)] +iSIG*(CS-CMM);
    %eval(tdUS);
    pS = p0 - 0.5*delta.*dU0 - 0.5*delta.*dUS;
    % Acceptation/reject
    U0 = 0.5*(sum(IND0.*Ni.*log(PSD0))+sum(IND0.*IYm./PSD0)+diag((C0-CMM)'*iSIG*(C0-CMM))');
    US = 0.5*(sum(INDS.*Ni.*log(PSDS))+sum(INDS.*IYm./PSDS)+diag((CS-CMM)'*iSIG*(CS-CMM))');
    K0 = sum(p0.^2,1)/2;KS = sum(pS.^2,1)/2;
    
    alpha(t) = min(1,exp((U0 + K0) - (US + KS)));u = rand;
    if u < alpha(t);
        Vacc = [Vacc(2:end) 1];C_est = CS;
        Crit(t+1)=-(US + KS);
    else
        Vacc = [Vacc(2:end) 0];C_est = C0;
        Crit(t+1)=Crit(t);
    end
    
    %----------------------------------------------------------------------
    % e- Storage
    tabC(:,t)   = C_est;
%     if (rem(t,10) == 0)
%         figure(1);clf
%         plot(log(abs(C_est'*LLc)));hold on;plot(log(IYm),'r')
%         pause(0.1)
%     end
end
% keyboard

% - OUTPUTS
EST.c2.MMSE = mean(tabC(1,Nbi:end));EST.c20.MMSE = mean(tabC(2,Nbi:end));
TAB.c2 = tabC(1,:);TAB.c20=tabC(2,:);
TAB.crit = Crit(2:end); [tmp,id]=max(TAB.crit); EST.c2.MAP = mean(tabC(1,id)); EST.c20.MAP = mean(tabC(2,id));
end





