function [xx,qi,ni,wr] = usft_angular_function(j1,j2,Nj,eta,ddr,dda)
% function [xx,qi,ni,wr] = usft_angular_function(j1,j2,nj,eta,ddr,dda)
% Outputs : 
% - xx{1} and xx{2} : first and second composant of the grid for USFT
% - qi : sparse with 1 when there is a radius
% - ni : nb of angle for each radius in the USFT
% - wr : radii of frequencies in the USFT

if nargin<6;dda=1;end;%% ANGULAR frequency resolution multiplier: 1 for original FFT resolution, 1/2 for twice the resolution, etc
if nargin<5;ddr=1;end;%RADIAL frequency resolution multiplier: 1 for original FFT resolution, 1/2 for twice the resolution, etc
if nargin<4;eta=1;end;% Bandwidth parameter


nj = Nj(:,1); % Assuming that leaders-matrix is square...

for j=j1:j2
    % Grid
    R{j}=ddr:ddr:sqrt(eta)*nj(j)/2;dr=ddr/2; % radii; for the final version, if working, the bandwidth parameter \eta should intervene at this level
%     nbpR{j}=2*ceil(pi*(R{j}+dr))/dda; % angles for different radii
%     nbpR{j}=4*ceil(pi*(R{j}+dr)/2)/dda; % angles for different radii
    nbpR{j}=8*ceil(pi*(R{j}+dr)/4)/dda; % angles for different radii
    nbpR{j}(pi*(R{j}+dr)/4<0.5)=4*ceil(pi*(R{j}(pi*(R{j}+dr)/4<0.5)+dr)/2)/dda;
%     nbpR{j}(pi*(R{j}+dr)/4<0.5)=2*ceil(pi*(R{j}(pi*(R{j}+dr)/4<0.5)+dr))/dda;

%     nbpR{j}=8*round(pi*(R{j}+dr)/4)/dda; % angles for different radii
    idr{j}=cumsum([1 nbpR{j}]); idr{j}=[0 idr{j}];
    RR{j}=zeros(1,idr{j}(end));AA{j}=zeros(1,idr{j}(end));
    for ii=2:length(idr{j})-1;
        RR{j}(idr{j}(ii)+1:idr{j}(ii+1))=R{j}(ii-1);
        AA{j}(idr{j}(ii)+1:idr{j}(ii+1))=(0:nbpR{j}(ii-1)-1)/(nbpR{j}(ii-1))*2*pi;
    end
   % keyboard
    xx{1}{j}=RR{j}.*cos(AA{j}); xx{2}{j}=RR{j}.*sin(AA{j});
    %
    % Prepare angular mean for USFT
    NN = length(RR{j});
    [rad,t,pos]  = unique(RR{j});
    qi{j} = sparse(1:NN,pos,ones(NN,1));
    ni{j}=([1 nbpR{j}]);
    wr{j} = [0 R{j}/nj(j)*2*pi];
end
