
function [Bxfi,Xr] = mrw2D(H,Lambda,N,L)
% produce a 2D MRW almost as
%
% L. Chevillard, R. Robert and V. Vargas
% EPL, 89 (2010) 54002
%

N=2*ceil(N/2);

MyDim=2;
mylength=N;
rndG1=randn(mylength,mylength);
rndG2=randn(mylength,mylength);


    MyAlpha=H +MyDim/2;
    
    %--- produce gaussian Random Walk with given power law cov
    %------ Synthese de la covariance
    dx=1/mylength;
    n2=[0:mylength/2];
    n2(mylength/2+2:mylength)=[-mylength/2+1:-1];
    n2=n2*dx;
    [X,Y]=meshgrid(n2,n2);
    
        lanorm=sqrt(X.^2+Y.^2);
    
    %----correlation
    mycorr=Lambda^2*log(max(1/L./(dx+lanorm),1));
    
    %------ Calcul des racines de la matrice circulante (=Fourier sur rz)
    L2=real(fftn(mycorr));
    
    %--- Compute MRW increments
    Xr = rndG2.*exp(real(ifftn(fftn(rndG1).*sqrt(L2)))) ;

    %---fractionally integrate
    Bxfi = fi_2d_fft(Xr,H+1);
    
    
    end








function M=RegulNorm(x,Delta)
MyFunc=inline('sqrt(6)*delta/(6*sqrt(pi)).*exp(-6*x.^2/delta^2)+(x+delta^2./(12*x)).*erf(sqrt(6)*x/delta)','x','delta');
M=zeros(size(x));
M(find(x==0))=(1/3)*sqrt(6)*Delta/sqrt(pi);
M(find(x))=MyFunc(x(find(x)),Delta);
end


function data_out = fi_2d_fft(data_in,alpha);

taille = size(data_in);taille = taille(1);

%% Fourier Transform
X=fft2(data_in);
kx=-taille/2:taille/2-1;
[Kx,Ky]=meshgrid(kx,kx);

%% Filtre
%H=0.5;
H = alpha - 1;
Kmod=sqrt(Kx.^2+Ky.^2);
listnull=find(Kmod==0);
Kmod(listnull)=min(Kmod(setdiff(1:length(Kmod(:)),listnull)))*ones(1,length(listnull));
Hfilt=1./(Kmod.^(1+H));

%% Filtrage et FFT inverse
Y=Hfilt.*fftshift(X);
Y=ifftshift(Y);
data_out=ifft2(Y);

end

